﻿Imports VinNOW.Environment.Common
Imports VinNOW.Data.SQL.ADONET
Imports VinNOW.Data
Imports VinNOW.Reports.RptCommon
Imports System.Data.SqlClient

Imports GrapeCity.ActiveReports
Imports GrapeCity.ActiveReports.Document

Public Class rptPmtDetail 

#Region "Class Vars"
    Private rptResources As RptCommon

    Dim FDate As Date
    Dim TDate As Date
    Dim sDate As Date
    Dim eDate As Date
    Dim fdDate As String
    Dim tdDate As String

    Dim WCPrePay As String
    Dim UnAppAmt As Decimal
    Dim PTtot As Double
    Dim GTtot As Double
    Dim GTtotApp As Double

    Dim aDataTable As New DataTable

    Dim Last_PaymentNO As Long

    Private Structure DTLDATA
        Dim PY_Payment_Number As Long
        Dim PY_Payment_Method As String
        Dim TR_Amount As Decimal
        Dim PY_Amount As Decimal
        Dim PY_UnApplied_Amt As Decimal
        Dim PY_CNUM As String
        Dim PY_Payment_Date As Date
        Dim Invnum As Long
        Dim ORDER_DATE As String
        Dim Pmt_CustNo As Long
        Dim CustName As String
        Dim Pmt_User As String
    End Structure

    Dim RD As DTLDATA
#End Region

#Region "Constructors"

    Public Sub New(ByVal aRptResource As RptCommon)
        MyBase.New()
        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        Me.rptResources = aRptResource

    End Sub

#End Region

    Private Sub rptPmtDetail_DataInitialize(sender As Object, e As EventArgs) Handles Me.DataInitialize
        '   Grouping control field settings
        Fields.Add("PmtType")
        ghPType.DataField = Fields("PmtType").Name

    End Sub

    Private Sub rptPmtDetail_FetchData(sender As Object, eArgs As SectionReport.FetchEventArgs) Handles Me.FetchData
        Static currRowNbr As Integer = 0
Retry:
        Try

            Dim aDataRow As DataRow
            If currRowNbr < aDataTable.Rows.Count Then
                aDataRow = aDataTable.Rows(currRowNbr)

                With RD
                    .PY_Payment_Number = Cvt2Dbl(Cvt2Str(aDataRow("PY Payment Number")))
                    .PY_Payment_Method = Cvt2Str(aDataRow("PY Payment Method"))
                    .PY_Amount = Cvt2Dbl(aDataRow("PY Amount"))
                    If Last_PaymentNO = .PY_Payment_Number Then
                        .PY_Amount = 0
                        Last_PaymentNO = .PY_Payment_Number
                        .PY_Payment_Number = 0
                    Else
                        Last_PaymentNO = .PY_Payment_Number
                    End If
                    .TR_Amount = Cvt2Dbl(Cvt2Str(aDataRow("TR Amount")))
                    .PY_UnApplied_Amt = Cvt2Dbl(aDataRow("PY Unapplied Amount"))
                    .PY_CNUM = Cvt2Str(aDataRow("PY CNUM"))
                    .PY_Payment_Date = aDataRow("PY Payment Date")
                    .Invnum = Cvt2Dbl(Cvt2Str(aDataRow("OR ORDER#")))
                    .ORDER_DATE = Cvt2Str(aDataRow("OR ORDER DATE"))
                    .Pmt_CustNo = aDataRow("PY Customer#")
                    If .Pmt_CustNo <> "1" Then
                        .CustName = Cvt2Str(aDataRow("Cust_Company"))
                        If .CustName = "" Then
                            .CustName = Cvt2Str(aDataRow("Cust_Recipient"))
                        End If
                    Else
                        .CustName = ""
                    End If
                    .Pmt_User = Cvt2Str(aDataRow("PY Add User"))

                    WCPrePay = Cvt2Str(aDataRow("PY_Wineclub_PrePmt"))
                    UnAppAmt = aDataRow("PY Unapplied Amount")
                End With

                fldPmtTyp.Text = rptResources.GetCC_Desc(StrConv(RD.PY_Payment_Method, vbUpperCase))
                '   set value of Field(s) used for Grouping
                Fields("PmtType").Value = RD.PY_Payment_Method


                currRowNbr += 1
                eArgs.EOF = False
            Else
                eArgs.EOF = True
                currRowNbr = 0
            End If



        Catch ex As Exception
            NetErrorHandler(ex, Nothing, , MsgBoxResult.Ok)
            Me.Stop()
            Throw New VNRptRuntimeException
        End Try


    End Sub

    Private Sub rptPmtDetail_ReportStart(sender As Object, e As EventArgs) Handles Me.ReportStart
        '--------------------------------------------------------------
        fldPmtTyp.Text = ""
        txtCompanyName.Text = gLicCompany

        Try
            FDate = rptResources.rptDef.FDate
            TDate = rptResources.rptDef.TDate
            fdDate = rptResources.rptDef.FDate
            tdDate = rptResources.rptDef.TDate

            lblReportDate.Text = "From: " & fdDate & "  To: " & tdDate
            lblHist.Visible = rptResources.rptDef.bHist
            fldSelection.Text = rptResources.rptDef.sSelTxt
            If rptResources.rptDef.sSelTxt = "" Then lblSelect.Visible = False

            aDataTable = GetDataTableFromQuery(rptResources.src_SQL, True)
            If aDataTable IsNot Nothing AndAlso aDataTable.Rows.Count > 0 Then
                '   do nothing
            Else
                Detail.Visible = False
            End If

            PTtot = 0
            GTtot = 0
            GTtotApp = 0

            With Me.PageSettings
                .Orientation = Section.PageOrientation.Landscape
                .PaperHeight = 8.5
                .PaperWidth = 11
            End With
            '--------------------------------------------------------------
        Catch ex As Exception
            NetErrorHandler(ex, Nothing, , MsgBoxResult.Ok)
            Me.Stop()
            Throw New VNRptRuntimeException
        End Try


    End Sub

    Private Sub Detail_Format1(sender As Object, e As EventArgs) Handles Detail.Format
        sErrLoc = "VinNOW.rptPmtDtl.Detail_Format"
        On Error GoTo Error_Trap
        '--------------------------------------------------------------
        Dim stmp As String
        With RD
            fldPtype.Text = .PY_Payment_Method

            fldPmtNo.Text = .PY_Payment_Number
            If .PY_Payment_Number = 0 Then
                fldPmtNo.Text = ""
            End If
            fldPmtAmt.Text = FormatCurrency(.PY_Amount)
            If .PY_Amount = 0 Then
                fldPmtAmt.Text = ""
            End If
            If .Invnum = 0 Then
                .TR_Amount = 0
            End If
            fldTrnAmt.Text = FormatCurrency(.TR_Amount)
            fldCnum.Text = .PY_CNUM
            fldPmtDate.Text = .PY_Payment_Date
            fldInv.Text = .Invnum
            fldInv.HyperLink = "I" & .Invnum
            fldDate.Text = .ORDER_DATE
            fldCust.Text = .Pmt_CustNo
            fldCust.HyperLink = "C" & .Pmt_CustNo
            fldCustName.Text = .CustName
            fldUser.Text = .Pmt_User
        End With
        If RD.Invnum = 0 Then
            If WCPrePay <> "" Then
                fldInv.Text = "WC PrePmt"
            Else
                fldInv.Text = "Unapplied"
            End If
        End If

        PTtot = PTtot + Cvt2Dbl(RD.PY_Amount)
        GTtot = GTtot + Cvt2Dbl(RD.PY_Amount)
        GTtotApp = GTtotApp + RD.TR_Amount

        If fldPtype.Text <> "Cash" And fldPtype.Text <> "Write-Off" Then
            If fldCnum.Text <> "" Then
                stmp = fldCnum.Text
                If fldPtype.Text = "Check" Or fldPtype.Text = "CMEMO" Or fldPtype.Text = "GIFT" Then
                    fldCnum.Text = stmp
                End If
            End If
        Else
            fldCnum.Text = ""
        End If
        '--------------------------------------------------------------
Std_Exit:
        Exit Sub
        'Resume 0
Error_Trap:
        ErrRsp = 0
        Call Error_Handler(ErrRsp, sErrLoc)
        Select Case ErrRsp
            Case vbAbort
                Call Error_Exit()
            Case vbRetry
                Resume
            Case vbIgnore
                Resume Next
        End Select
        Err.Clear()

    End Sub

    Private Sub gfGT_Format1(sender As Object, e As EventArgs) Handles gfGT.Format
        fldGrandTot.Text = FormatCurrency(GTtot)
        fldTotApp.Text = FormatCurrency(GTtotApp)
    End Sub

    Private Sub gfPType_Format(sender As Object, e As EventArgs) Handles gfPType.Format
        fldTypeTot.Text = FormatCurrency(PTtot)
        PTtot = 0
    End Sub

    Private Sub PageFooter_Format(sender As Object, e As EventArgs) Handles PageFooter.Format
        LB_DateTime.Text = Now
    End Sub

End Class
